# VeriTrans4G ワンクリック継続課金サービス テスト取引サンプルプログラム
本ソフトウェアはVeriTrans4G ワンクリック継続課金サービスやクレジットカード決済のAPIに対し、CSVでパラメータを読み込んで要求電文を送信、結果を出力するPowerShell用サンプルプログラムです。  
開発時のテスト会員やテスト取引の作成などにご利用ください。

***

## 動作に必要なソフトウェア
本サンプルプログラムの実行に必要なソフトウェアは以下の通りです。
- [PowerShell 7.2以上](https://docs.microsoft.com/ja-jp/powershell/scripting/overview?view)

Windowsプラットフォームで実行する場合は、実行ポリシーを事前に設定しておく必要があります。  
[実行ポリシーについて - PowerShell | Microsoft Docs](https://docs.microsoft.com/ja-jp/powershell/module/microsoft.powershell.core/about/about_execution_policies)

***

## 同梱ファイルについて
本パッケージには以下のファイルが含まれています。

|ファイル名|説明|
|----|----|
|mdk.ps1|CSVを読み込み、VeriTrans 4G決済ゲートウェイに要求電文を送信し、応答を出力するプログラム|

以下のCSVファイルは、ファイル名が各実行コマンド(要求電文送信先API)となっているサンプルCSVファイルです。

|ファイル名|説明|
|----|----|
|card-authorize.csv|カード与信API|
|card-reauthorize.csv|カード再与信API|
|card-capture.csv|カード売上API|
|card-cancel.csv|カードキャンセルAPI|
|account-add.csv|会員情報追加API|
|account-update.csv|会員情報更新API|
|account-delete.csv|会員情報削除API|
|account-restore.csv|会員情報復元API|
|account-link.csv|会員情報紐付API|
|account-copy.csv|会員情報複製API|
|cardinfo-add.csv|登録カード追加API|
|cardinfo-get.csv|登録カード取得API|
|cardinfo-update.csv|登録カード更新API|
|cardinfo-delete.csv|登録カード削除API|
|recurring-add.csv|継続課金追加API|
|recurring-get.csv|継続課金取得API|
|recurring-update.csv|継続課金更新API|
|recurring-delete.csv|継続課金削除API|

***

## 各実行コマンドに対応するCSVファイルフォーマットについて

実行コマンドに対応するCSVファイルフォーマットは以下の通りです。

### card-authorize (カード与信)
#### 入力CSV
|フィールド名|項目名|設定|
|----|----|----|
|orderId|取引ID|必須|
|amount|決済金額|必須|
|accountId|会員ID|必須|
|cardId|カードID|任意|
|jpo|支払種別|任意|
|withCapture|売上フラグ|任意|
|token|トークン|任意|
#### 出力CSV
|フィールド名|項目名|
|----|----|
|orderId|取引ID|
|serviceType|決済サービスタイプ|
|mstatus|処理結果コード|
|vResultCode|詳細結果コード|
|merrMsg|エラーメッセージ|
|marchTxn|電文ID|
|custTxn|取引毎に付くID|
|pending|ペンディング|
|loopback|ループバック|
|resAuthCode|応答承認番号|
|resCenterErrorCode|応答センターエラーコード|
|acquirerCode|仕向け先コード|
|accountId|会員ID|
|cardId|カードID|
|cardNumber|マスクカード番号|
|cardExpire|有効期限|
|defaultCard|標準カードフラグ|
|processId|会員管理処理番号|
|status|会員管理ステータス|
|message|会員管理メッセージ|
<br><br>

### card-reauthorize (カード再与信)
#### 入力CSV
|フィールド名|項目名|設定|
|----|----|----|
|orderId|取引ID|必須|
|originalOrderId|取引ID|必須|
|amount|決済金額|必須|
|jpo|支払種別|任意|
|withCapture|売上フラグ|任意|
#### 出力CSV
|フィールド名|項目名|
|----|----|
|orderId|取引ID|
|serviceType|決済サービスタイプ|
|mstatus|処理結果コード|
|vResultCode|詳細結果コード|
|merrMsg|エラーメッセージ|
|marchTxn|電文ID|
|custTxn|取引毎に付くID|
|pending|ペンディング|
|loopback|ループバック|
|resAuthCode|応答承認番号|
|resCenterErrorCode|応答センターエラーコード|
|acquirerCode|仕向け先コード|
<br><br>

### card-capture (カード売上)
#### 入力CSV
|フィールド名|項目名|設定|
|----|----|----|
|orderId|取引ID|必須|
|amount|決済金額|必須|
#### 出力CSV
card-reauthorizeコマンドと共通です。
<br><br>

### card-cancel (カードキャンセル)
#### 入力CSV
|フィールド名|項目名|設定|
|----|----|----|
|orderId|取引ID|必須|
|amount|決済金額|任意|
#### 出力CSV
card-reauthorizeコマンドと共通です。
<br><br>

### account-add (会員情報追加)
#### 入力CSV
|フィールド名|項目名|設定|
|----|----|----|
|accountId|会員ID|必須|
|createDate|入会年月日|任意|
#### 出力CSV
|フィールド名|項目名|
|----|----|
|accountId|会員ID|
|serviceType|決済サービスタイプ|
|mstatus|処理結果コード|
|vResultCode|詳細結果コード|
|merrMsg|エラーメッセージ|
|processId|会員管理処理番号|
|status|会員管理ステータス|
|message|会員管理メッセージ|
<br><br>

### account-update (会員情報更新)
#### 入力CSV
account-addコマンドと共通です。
#### 出力CSV
account-addコマンドと共通です。
<br><br>

### account-delete (会員情報削除)
#### 入力CSV
|フィールド名|項目名|設定|
|----|----|----|
|accountId|会員ID|必須|
|deleteDate|退会年月日|任意|
|forceDeleteDate|強制退会フラグ|任意|
|deleteCardInfo|カード情報削除フラグ|任意|
#### 出力CSV
account-addコマンドと共通です。
<br><br>

### account-restore (会員情報復元)
#### 入力CSV
account-addコマンドと共通です。
#### 出力CSV
account-addコマンドと共通です。
<br><br>

### account-link (会員情報紐付)
#### 入力CSV
|フィールド名|項目名|設定|
|----|----|----|
|accountId|会員ID|必須|
|originalOrderId|元取引ID|必須|
|createDate|入会年月日|任意|
|addCardInfo|カード情報追加フラグ|任意|
|defaultCard|標準カードフラグ|任意|
|updater|洗替実施フラグ|任意|
#### 出力CSV
account-addコマンドと共通です。
<br><br>

### account-copy (会員情報複製)
#### 入力CSV
|フィールド名|項目名|設定|
|----|----|----|
|accountId|会員ID|必須|
|originalAccountId|元会員ID|必須|
|createDate|入会年月日|任意|
|deleteDate|退会年月日|任意|
|forceDeleteDate|強制退会フラグ|任意|
|deleteCardInfo|カード情報削除フラグ|任意|
|deleteOriginalAccountId|元会員ID退会フラグ|任意|
|addCardInfo|カード情報追加フラグ|任意|
|defaultCardOnly|標準カード限定フラグ|任意|
|cleaningConfig|洗替設定フラグ|任意|
#### 出力CSV
account-addコマンドと共通です。
<br><br>

### cardinfo-add (登録カード追加)
#### 入力CSV
|フィールド名|項目名|設定|
|----|----|----|
|accountId|会員ID|必須|
|defaultCard|標準カードフラグ|任意|
|token|トークン|任意|
|withAuthorize|与信実施フラグ|任意|
|updater|洗替実施フラグ|任意|
#### 出力CSV
|フィールド名|項目名|
|----|----|
|accountId|会員ID|
|cardId|カードID|
|cardNumber|マスクカード番号|
|cardExpire|有効期限|
|defaultCard|標準カードフラグ|
|serviceType|決済サービスタイプ|
|mstatus|処理結果コード|
|vResultCode|詳細結果コード|
|merrMsg|エラーメッセージ|
|processId|会員管理処理番号|
|status|会員管理ステータス|
|message|会員管理メッセージ|
<br><br>

### cardinfo-get (登録カード取得)
#### 入力CSV
|フィールド名|項目名|設定|
|----|----|----|
|accountId|会員ID|必須|
|defaultCard|標準カードフラグ|任意|
|token|トークン|任意|
|withAuthorize|与信実施フラグ|任意|
|updater|洗替実施フラグ|任意|
#### 出力CSV
cardinfo-addコマンドと共通ですが、複数の登録カードがある場合は複数行出力されます。
<br><br>

### cardinfo-update (登録カード更新)
#### 入力CSV
|フィールド名|項目名|設定|
|----|----|----|
|accountId|会員ID|必須|
|cardId|カードID|必須|
|defaultCard|標準カードフラグ|任意|
|token|トークン|任意|
|withAuthorize|与信実施フラグ|任意|
|updater|洗替実施フラグ|任意|
#### 出力CSV
cardinfo-addコマンドと共通です。
<br><br>

### cardinfo-delete (登録カード削除)
#### 入力CSV
|フィールド名|項目名|設定|
|----|----|----|
|accountId|会員ID|必須|
|cardId|カードID|必須|
|defaultCardId|標準カードID|任意|
#### 出力CSV
cardinfo-addコマンドと共通です。
<br><br>

### recurring-add (継続課金追加)
#### 入力CSV
|フィールド名|項目名|設定|
|----|----|----|
|accountId|会員ID|必須|
|groupId|課金グループID|必須|
|cardId|カードID|任意|
|defaultCard|標準カードフラグ|任意|
|updater|洗替実施フラグ|任意|
|startDate|課金開始日|任意|
|endDate|課金終了日|任意|
|oneTimeAmount|都度/初回課金金額|任意|
|amount|継続課金金額|任意|
|recurringMemo1|継続課金用メモ1|任意|
|recurringMemo2|継続課金用メモ2|任意|
|recurringMemo3|継続課金用メモ3|任意|

#### 出力CSV
|フィールド名|項目名|
|----|----|
|accountId|会員ID|
|groupId|課金グループID|
|cardId|カードID|
|serviceType|決済サービスタイプ|
|mstatus|処理結果コード|
|vResultCode|詳細結果コード|
|merrMsg|エラーメッセージ|
|processId|会員管理処理番号|
|status|会員管理ステータス|
|message|会員管理メッセージ|
<br><br>


### recurring-update (継続課金更新)
#### 入力CSV
継続課金追加コマンドと共通です。

#### 出力CSV
継続課金追加コマンドと共通です。
<br><br>

### recurring-delete (継続課金削除)
#### 入力CSV
|フィールド名|項目名|設定|
|----|----|----|
|accountId|会員ID|必須|
|groupId|課金グループID|必須|
|endDate|課金終了日|任意|
|finalCharge|次回課金終了フラグ|任意|

#### 出力CSV
継続課金追加コマンドと共通です。
<br><br>

### recurring-get (継続課金取得)
#### 入力CSV
|フィールド名|項目名|設定|
|----|----|----|
|accountId|会員ID|必須|

#### 出力CSV
継続課金追加コマンドと共通ですが、複数の継続課金グループへの登録がある場合は複数行出力されます。
<br><br>


各フィールドの詳細や応答パラメータについては、合わせて以下のドキュメントも参照ください。
* VeriTrans4G インターフェース詳細 ～クレジットカード決済～
* VeriTrans4G 開発ガイド別冊 ワンクリック継続課金サービス 会員管理機能 インターフェース詳細

***

## サンプルプログラムの実行方法について

実行前に `mdk.ps1` をエディタなどで開き、マーチャントCCIDやマーチャント認証鍵を記入して保存してください。これらの情報やToken API Keyはマーチャント管理ポータルのAPI設定情報画面に記載されています。
```powershell
static [string]$merchantCcId = "{Set Merchant CcId here}"
static [string]$merchantSecret = "{Set Merchant Secret Key here}"
```

その後、Windows TerminalなどからPowerShellを開き、以下のように第一引数に実行コマンド、第二引数に読み込むCSVファイルを指定して実行してください。
```
.\mdk.ps1 account-add .\account-add.csv
```

処理完了後、読み込みCSVファイルと同じディレクトリに、`{入力ファイル名}_{yyMMdd_HHmmss}_result.csv`という名前で出力ファイルが作成されます。  
また、同じディレクトリに`mdkps_{yyMMdd_HHmmss}.log`という名前で、要求、応答電文のログファイルが保存されます。

### テスト取引用のトークン取得について

テスト用カード番号を利用してトークンを取得したい場合、WSL 2などのLinux環境からcurl等のコマンドを利用してトークンAPIにJSON電文を送信し、応答を得ることが可能です。  
```
curl -X POST -H "Content-Type: application/json" -d '{"token_api_key":"-- Token API Key here --","card_number":"-- test card number here --","card_expire":"-- any mm/yy here --","security_code":"-- any 3-4 digit number here --"}' https://api3.veritrans.co.jp/4gtoken
```

テスト用カード番号およびトークンAPIについては、以下のドキュメントを参照ください。
* VeriTrans4G 導入テストガイド
* VeriTrans4G MDKトークン 開発ガイド

***

## 改版履歴

- 2024/03 PowerShell用サンプルプログラム ver 1.0.1 リリース
    - 接続先ドメインを新環境(api3.veritrans.co.jp)に変更
- 2022/04 初版公開

***

##### Copyright 2024 DG Financial Technology,Inc.
